from math import inf

class Cell:
    def __init__(self):
        self.x = None
        self.y = None
        self.flag = inf
        self.last_touched_by = -1
        #self.cell_type = ''
    def get_left(self, grid):
        if self.y == 0:
            return None
        return grid[self.x][self.y-1]
    def get_right(self, grid):
        if self.y == len(grid[0])-1:
            return None
        return grid[self.x][self.y+1]
    def get_up(self, grid):
        if self.x == 0:
            return None
        return grid[self.x-1][self.y]
    def get_down(self, grid):
        if self.x == len(grid)-1:
            return None
        return grid[self.x+1][self.y]

    def set_cell_type(self, cell_type):
        self.cell_type = cell_type

    def output_coords(self):
        print(f'{self.x + 1} {self.y + 1}')

def dejkstra(cell, grid, holes, visited_holes, c, touch_id):
    if cell.cell_type == 'H':
        visited_holes.append(cell)
    if cell.last_touched_by != touch_id:
        cell.flag = c
        cell.last_touched_by = touch_id
    else:
        if cell.flag > c:
            cell.flag = c
    if set(visited_holes) == set(holes):
        return c

    up_l, down_l, left_l, right_l = inf, inf, inf, inf

    up = cell.get_up(grid)
    down = cell.get_down(grid)
    left = cell.get_left(grid)
    right = cell.get_right(grid)

    neighbours = [left, right, up, down]
    distances = []
    for i in neighbours:
        if i is not None:
            if (i.last_touched_by != touch_id or i.flag > c) and i.cell_type != 'F':
                distances.append(dejkstra(i, grid, holes, visited_holes, c+1, touch_id))
                print(f'Distance starting from {i.x} {i.y} is {distances[-1]}')
    if any(distances):
        return max(distances)
    return c
    
    

inp = input().split(' ')
n = int(inp[0])
m = int(inp[1])


holes = []
grid = [['' for _ in range(m)] for _ in range(n)]

for x in range(n):
    line = input()
    for y in range(m):
        cell = Cell()
        cell.x = x
        cell.y = y
        cell.set_cell_type(line[y])
        grid[x][y] = cell
        if line[y] == 'H':
            holes.append(cell)

best_cells = []
best_l = inf

tid = 0

for i in grid:
    for j in i:
        l = dejkstra(j, grid, holes, [], 0, tid)
        print(l)
        if l < best_l:
            best_cells = [j]
            best_l = l
        elif l == best_l:
            best_cells.append(j)
        tid += 1

for i in best_cells:
    i.output_coords()

