from math import inf

class Cell:
    def __init__(self):
        self.x = None
        self.y = None
        self.flag = inf
        self.last_touched_by = -1
        #self.cell_type = ''
    def get_left(self, grid):
        if self.y == 0:
            return None
        return grid[self.x][self.y-1]
    def get_right(self, grid):
        if self.y == len(grid[0])-1:
            return None
        return grid[self.x][self.y+1]
    def get_up(self, grid):
        if self.x == 0:
            return None
        return grid[self.x-1][self.y]
    def get_down(self, grid):
        if self.x == len(grid)-1:
            return None
        return grid[self.x+1][self.y]

    def set_cell_type(self, cell_type):
        self.cell_type = cell_type

    def output_coords(self):
        print(f'{self.x + 1} {self.y + 1}')

class Queue:
    def __init__(self):
        self.lst = []
    def add(self, obj):
        self.lst.append(obj)
    def get(self):
        try:
            return self.lst.pop(0)
        except:
            return None
    def is_empty(self):
        return len(self.lst) == 0
def dejkstra(cell, grid, holes, visited_holes, c, touch_id, q):
    print(f'Checkng cell {cell.x} {cell.y}')
    if cell.cell_type == 'F':
        return inf
    cell.flag = c
    cell.last_touched_by = touch_id

    if cell.cell_type == 'H':
        visited_holes.append(cell)
        if set(visited_holes) == set(holes):
            return c

    j = 0
    neighbours = [cell.get_left(grid), cell.get_right(grid), cell.get_up(grid), cell.get_down(grid)]
    for i in neighbours:
        if i is not None and i.cell_type != 'F' and (i.last_touched_by != touch_id or i.flag > cell.flag):
            q.add(i)
            j += 1
    if not any(q.lst):
        return inf
    distances = []
    for i in range(j):
        distances.append(dejkstra(q.get(), grid, holes, visited_holes, c+1, touch_id, q))
    return min(distances)

inp = input().split(' ')
n = int(inp[0])
m = int(inp[1])


holes = []
grid = [['' for _ in range(m)] for _ in range(n)]

for x in range(n):
    line = input()
    for y in range(m):
        cell = Cell()
        cell.x = x
        cell.y = y
        cell.set_cell_type(line[y])
        grid[x][y] = cell
        if line[y] == 'H':
            holes.append(cell)

hole_y = [i.y for i in holes]
hole_y.sort()

s = min(hole_y)+max(hole_y)
if s % 2 == 0:
    print(1, (s/2)+1)
else:
    print(1, (s//2)+1)
    print(1, (s//2)+2)

