from collections import deque

n, m = map(int, input().split())
field = []
INF = float('inf')

#((i-1, j), (i, j+1), (i+1, j),(i, j-1))

for i in range(n):
    field.append(tuple(input()))

field = tuple(field)
'''
for a in field:
    print(*a)
print()
'''

holes = tuple((i, j) for j in range(m) for i in range(n) if field[i][j] == 'H')
visited = [[False]*m for i in range(n)]
distance = [[INF]*m for i in range(n)]


def finddistance(start):
    visited = set(start)
    distance = [[INF]*m for i in range(n)]
    i, j = start
    distance[i][j] = 0
    queue = deque([start])
    while queue:
        i, j = queue.popleft()
        if (i, j) in visited:
            continue

        visited.add((i, j))
        current_dist = distance[i][j]

        if i > 0 and field[i-1][j] != 'F': #N
            distance[i-1][j] = min(current_dist + 1, distance[i-1][j])
            queue.append((i-1, j))

        if j<m-1 and field[i][j+1] != 'F': #E
            distance[i][j+1] = min(current_dist + 1, distance[i][j+1])
            queue.append((i, j+1))

        if i<n-1 and field[i+1][j] != 'F': #S
            distance[i+1][j] = min(current_dist + 1, distance[i+1][j])
            queue.append((i+1, j))

        if j > 0 and field[i][j-1] != 'F': #W
            distance[i][j-1] = min(current_dist + 1, distance[i][j-1])
            queue.append((i, j-1))

    return distance

master = [[0]*m for i in range(n)]

for hole in holes:
    distance = finddistance(hole)
    for i in range(n):
        for j in range(m):
            master[i][j] = max(master[i][j], distance[i][j])

indexes = []
min_value = INF
for i, row in enumerate(master):
    for j, value in enumerate(row):
        cur = master[i][j]
        if cur < min_value:
            min_value = cur
            indexes = [(i+1, j+1)]
        elif cur != INF and cur == min_value:
            indexes.append((i+1, j+1))
print(len(indexes))
for i in range(len(indexes)):
    print(*indexes[i])