from math import sqrt
from statistics import mean

n, m = map(int, input().split(' '))
world = []
for _ in range(n): world += [list(input())]
assert len(world) == n
assert len(world[0]) == m

def distance(p1, p2):
    x1, y1 = p1; x2, y2 = p2
    return sqrt((x1 - x2)**2 + (y1 - y2)**2)

def findPosOfType(type: str, world: list[list[str]]) -> list[tuple[int, int]]:
    acc = []
    for x in range(n):
        for y in range(m-1):
            if world[y][x] != type: continue
            acc.append((y, x))
    return acc

def heuristic(point: tuple[int, int], world: list[list[str]]) -> float:
    mole_distances = [distance(x, point) for x in findPosOfType('H', world)]
    return sum(mole_distances)

def solve(world: list[list[str]]) -> list[tuple[int, int]]:
    empty_cells = findPosOfType('.', world)
    choices = sorted(empty_cells, key=lambda p: heuristic(p, world))
    return [x for x in choices if heuristic(x, world) > mean([heuristic(y, world) for y in choices])]

if __name__ == "__main__":
    answer_set = solve(world)
    print(len(answer_set))

    for i in answer_set:
        print(" ".join( list((map(lambda x: str(x+1), i))) ))