#include <iostream>
#include <map>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int length, ops;
    cin >> length >> ops;
    ops += 1;

    map<int, int> permutation_map{};

    for (int i = 0; i < length; i++) {
        int element;
        cin >> element;

        permutation_map[element] = i + 1;
    }

    vector<long long> loop(length, 0);
    vector<long long> loop_sums(length, 0);
    vector<long long> answers(length + 1, -1);

    for (int i = 1; i <= length; i++) {
        if (answers[i] != -1) {
            continue;
        }

        int current = permutation_map[i];
        int index = 1;

        loop[0] = i;
        loop_sums[0] = i;

        while (current != i) {
            loop[index] = current;
            loop_sums[index] = loop_sums[index - 1] + current;
            current = permutation_map[current];

            index += 1;
        }

        int loop_len = index;
        int full_loops = ops / loop_len;
        int full_answer = full_loops * loop_sums[loop_len - 1];
        int extra = ops % loop_len;

        if (extra > 0) {
            int extra_sum = loop_sums[extra - 1];

            for (int j = 0; j < loop_len; j++) {
                answers[loop[j]] = full_answer + extra_sum - loop[j];
                extra_sum += loop[(extra + j) % loop_len] - loop[j];
            }
        } else {
            for (int j = 0; j < loop_len; j++) {
                answers[loop[j]] = full_answer - loop[j];
            }
        }

        loop.assign(loop_len, 0);
        loop_sums.assign(loop_len, 0);
    }

    for (int i = 1; i <= length; i++) {
        cout << answers[i] << " ";
    }

    cout << "\n";

    // for (int i = 0; i < 2; i++) {
    //     cout << i << ": ";

    //     for (int sum : loops[i]) {
    //         cout << sum << " ";
    //     }

    //     cout << "\n";
    // }

    // for (int i = 1; i <= length; i++) {
    //     if (permutation_map[i] == i) {
    //         cout << (ops - 1) * i << " ";
    //         continue;
    //     }

    //     auto [loop_id, loop_index] = element_loops[i];
    //     vector<long long>* loop = loops[loop_id];

    //     int full_loops = ops / loop->size();
    //     int extra = ops % loop->size();

    //     long long result = full_loops * loop->back() - i;

    //     if (extra > 0) {
    //         int start_index = loop_index - 1;
    //         int end_index = min((int)loop->size() - 1, loop_index + extra - 1);
    //         int overlap_end_index = loop_index + extra - loop->size() - 1;

    //         result += (*loop)[end_index] + (overlap_end_index >= 0 ? (*loop)[overlap_end_index] : 0) - (start_index >= 0 ? (*loop)[start_index] : 0);
    //         // cout << i << " " << (*loop)[end_index] << " " << (overlap_end_index >= 0 ? (*loop)[overlap_end_index] : 0) << " " << (start_index >= 0 ? (*loop)[start_index] : 0) << "\n";
    //     }

    //     cout << result << " ";
    // }

    // cout << "\n";

    return 0;
}
