#include <iostream>
#include <map>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int length, ops;
    cin >> length >> ops;
    ops += 1;

    map<int, int> permutation_map{};

    for (int i = 0; i < length; i++) {
        int element;
        cin >> element;

        permutation_map[element] = i + 1;
    }

    int loop[length];
    long long loop_sums[length];
    long long answers[length + 1];

    memset(loop, 0, length * sizeof(loop[0]));
    memset(loop_sums, 0, length * sizeof(loop_sums[0]));
    memset(answers, 0xff, (length + 1) * sizeof(loop_sums[0]));

    for (int i = 1; i <= length; i++) {
        if (answers[i] != -1) {
            continue;
        }

        if (permutation_map[i] == i) {
            answers[i] = ((long long)(ops - 1)) * ((long long)i);
            continue;
        }

        int current = permutation_map[i];
        int index = 1;

        loop[0] = i;
        loop_sums[0] = i;

        while (current != i) {
            loop[index] = current;
            loop_sums[index] = loop_sums[index - 1] + current;
            current = permutation_map[current];

            index += 1;
        }

        int loop_len = index;
        int full_loops = ops / loop_len;
        long long full_answer = (long long)full_loops * loop_sums[loop_len - 1];
        int extra = ops % loop_len;

        if (extra > 0) {
            long long extra_sum = loop_sums[extra - 1];

            for (int j = 0; j < loop_len; j++) {
                answers[loop[j]] = full_answer + extra_sum - (long long)loop[j];
                extra_sum += (long long)loop[(extra + j) % loop_len] - (long long)loop[j];
            }
        } else {
            for (int j = 0; j < loop_len; j++) {
                answers[loop[j]] = full_answer - (long long)loop[j];
            }
        }

        memset(loop, 0, loop_len * sizeof(loop[0]));
        memset(loop_sums, 0, loop_len * sizeof(loop_sums[0]));
    }

    for (int i = 1; i <= length; i++) {
        cout << answers[i] << " ";
    }

    cout << "\n";

    return 0;
}
