#include <bits/stdc++.h>
using namespace std;
using ll = long long;

struct Fenwick {
    vector<ll> fen;
    ll n;

    Fenwick(ll m) {
        n = m;
        fen.assign(n + 1, INT_MIN);
    }


    ll pref(ll r) {
        return 1;
    }

    void upd(ll i, ll vl) {
        
    }
};

struct query_t {
    ll l, r, i;

    bool operator<(query_t& quer) {
        return r < quer.r;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n, q;
    cin >> n >> q;

    int a[n + 1];
    for (int i = 0; i < n; i++) {
        cin >> a[i + 1];
    }

    ll pref[n + 1];
    pref[0] = 0;
    for (ll i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i];
    }

    int lg = log2(n) + 2;

    vector<vector<int>> sp(n + 1, vector<int>(lg));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            sp[i][0] = a[i];
        }
    }

    for (int k = 1; k <= lg; k++) {
        for (int i = 1; i <= n - (1 << k) + 1; i++) {
            sp[i][k] = __gcd(sp[i][k - 1], sp[i + (1 << (k - 1))][k - 1]);
        }
    }

    vector<int> logs(n + 1);

    logs[1] = 0;
    int nxt = 1;

    for (int i = 2; i <= n; i++) {
        if (i == (1 << nxt)) {
            nxt++;
        }
        logs[i] = nxt - 1;
    }

    auto query = [&](int l, int r) {
        int lg = logs[r - l + 1];
        return __gcd(sp[l][lg], sp[r - (1 << lg) + 1][lg]);
    };

    vector<int> ind[n + 1];


    vector<int> events[n + 1];

    // for (int i = 1; i <= n; i++) {
    //     int curg;
    //     int cur = i;

    //     while (cur <= n) {
    //         curg = query(i, cur);
    //         int beg = cur + 1;
    //         int end = n;

    //         while (beg <= end) {
    //             int mid = (beg + end) / 2;

    //             if (query(i, mid) != curg) {
    //                 end = mid - 1;
    //             }
    //             else {
    //                 beg = mid + 1;
    //             }
    //         }

    //         events[end].push_back(i);
    //         cur = end + 1;

    //     }
    // }

    // for (int i = n; i >= 1; i--) {
    //     int curg;
    //     int cur = i;

    //     while (cur >= 1) {
    //         curg = query(cur, i);
    //         int beg = 1;
    //         int end = cur - 1;

    //         while (beg <= end) {
    //             int mid = (beg + end) / 2;

    //             if (query(mid, i) != curg) {
    //                 beg = mid + 1;
    //             }
    //             else {
    //                 end = mid - 1;
    //             }
    //         }

    //         ind[i].push_back(beg);
    //         cur = beg - 1;
    //     } 
    // }

    vector<query_t> quer(q);

    for (int i = 0; i < q; i++) {
        cin >> quer[i].l >> quer[i].r;
        quer[i].i = i;
    }

    sort(quer.begin(), quer.end());

    Fenwick fen = Fenwick(n);

    ll ans[q];

    int nxtr = 1;

    for (int i = 0; i < q; i++) {
        while (nxtr <= quer[i].r) {
            for (int event : events[nxtr]) {
                fen.upd(event, (pref[nxtr] - pref[event - 1]) * query(event, nxtr));
            }
            nxtr++;
        }

        ll res = fen.pref(quer[i].l);

        for (int index : ind[quer[i].r]) {
            if (index < quer[i].l) break;
            res = max(res, (pref[quer[i].r] - pref[index - 1]) * query(index, quer[i].r));
        }
        res = max(res, (pref[quer[i].r] - pref[quer[i].l - 1]) * query(quer[i].l, quer[i].r));

        ans[quer[i].i] = res;
    }

    for (int i = 0; i < q; i++) {
        printf("%lld\n", ans[i]);
    }

}
